using System;
using System.Runtime.InteropServices;

namespace Creaturelibbattling.Generated
{
    internal static class Battle
    {
        /// <param name="out">Battle *&</param>
        /// <param name="library">const BattleLibrary *</param>
        /// <param name="partyArr">BattleParty * *</param>
        /// <param name="numberOfParties">long unsigned int</param>
        /// <param name="canFlee">bool</param>
        /// <param name="numberOfSides">unsigned char</param>
        /// <param name="creaturesPerSide">unsigned char</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_Construct")]
        internal static extern byte Construct(ref IntPtr @out, IntPtr library, IntPtr partyArr, ulong numberOfParties, bool canFlee, byte numberOfSides, byte creaturesPerSide);

        /// <param name="p">const Battle *</param>
        /// <returns>void</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_Destruct")]
        internal static extern void Destruct(IntPtr p);

        /// <param name="p">const Battle *</param>
        /// <returns>const BattleLibrary *</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_GetLibrary")]
        internal static extern IntPtr GetLibrary(IntPtr p);

        /// <param name="out">bool&</param>
        /// <param name="p">Battle *</param>
        /// <param name="turnChoice">const BaseTurnChoice *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_CanUse")]
        internal static extern byte CanUse(ref bool @out, IntPtr p, IntPtr turnChoice);

        /// <param name="out">bool&</param>
        /// <param name="p">Battle *</param>
        /// <param name="turnChoice">BaseTurnChoice *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_TrySetChoice")]
        internal static extern byte TrySetChoice(ref bool @out, IntPtr p, IntPtr turnChoice);

        /// <param name="p">const Battle *</param>
        /// <returns>bool</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_CanFlee")]
        internal static extern bool CanFlee(IntPtr p);

        /// <param name="p">Battle *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_CheckChoicesSetAndRun")]
        internal static extern byte CheckChoicesSetAndRun(IntPtr p);

        /// <param name="p">const Battle *</param>
        /// <returns>ChoiceQueue *</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_GetCurrentTurnQueue")]
        internal static extern IntPtr GetCurrentTurnQueue(IntPtr p);

        /// <param name="p">Battle *</param>
        /// <returns>BattleRandom *</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_GetRandom")]
        internal static extern IntPtr GetRandom(IntPtr p);

        /// <param name="out">bool&</param>
        /// <param name="p">const Battle *</param>
        /// <param name="c">Creature *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_CreatureInField")]
        internal static extern byte CreatureInField(ref bool @out, IntPtr p, IntPtr c);

        /// <param name="out">Creature *&</param>
        /// <param name="p">const Battle *</param>
        /// <param name="side">unsigned char</param>
        /// <param name="target">unsigned char</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_GetCreature")]
        internal static extern byte GetCreature(ref IntPtr @out, IntPtr p, byte side, byte target);

        /// <param name="p">Battle *</param>
        /// <param name="side">unsigned char</param>
        /// <param name="target">unsigned char</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_ForceRecall")]
        internal static extern byte ForceRecall(IntPtr p, byte side, byte target);

        /// <param name="p">Battle *</param>
        /// <param name="side">unsigned char</param>
        /// <param name="target">unsigned char</param>
        /// <param name="c">Creature *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_SwitchCreature")]
        internal static extern byte SwitchCreature(IntPtr p, byte side, byte target, IntPtr c);

        /// <param name="out">bool&</param>
        /// <param name="p">const Battle *</param>
        /// <param name="side">unsigned char</param>
        /// <param name="target">unsigned char</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_CanSlotBeFilled")]
        internal static extern byte CanSlotBeFilled(ref bool @out, IntPtr p, byte side, byte target);

        /// <param name="p">Battle *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_ValidateBattleState")]
        internal static extern byte ValidateBattleState(IntPtr p);

        /// <param name="p">const Battle *</param>
        /// <returns>bool</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_HasEnded")]
        internal static extern bool HasEnded(IntPtr p);

        /// <param name="p">const Battle *</param>
        /// <returns>bool</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_HasConclusiveResult")]
        internal static extern bool HasConclusiveResult(IntPtr p);

        /// <param name="p">const Battle *</param>
        /// <returns>bool</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_GetWinningSide")]
        internal static extern bool GetWinningSide(IntPtr p);

        /// <param name="p">const Battle *</param>
        /// <returns>long unsigned int</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_GetSidesCount")]
        internal static extern ulong GetSidesCount(IntPtr p);

        /// <param name="p">const Battle *</param>
        /// <returns>const BattleSide * *</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_GetSides")]
        internal static extern IntPtr GetSides(IntPtr p);

        /// <param name="p">Battle *</param>
        /// <param name="key">const char *</param>
        /// <returns>Script *</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_GetVolatileScript")]
        internal static extern IntPtr GetVolatileScript(IntPtr p, IntPtr key);

        /// <param name="p">Battle *</param>
        /// <param name="key">const char *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_AddVolatileScriptByName")]
        internal static extern byte AddVolatileScriptByName(IntPtr p, IntPtr key);

        /// <param name="p">Battle *</param>
        /// <param name="script">Script *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_AddVolatileScript")]
        internal static extern byte AddVolatileScript(IntPtr p, IntPtr script);

        /// <param name="p">Battle *</param>
        /// <param name="key">const char *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_RemoveVolatileScript")]
        internal static extern byte RemoveVolatileScript(IntPtr p, IntPtr key);

        /// <param name="p">Battle *</param>
        /// <param name="script">Script *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_RemoveVolatileScriptWithScript")]
        internal static extern byte RemoveVolatileScriptWithScript(IntPtr p, IntPtr script);

        /// <param name="p">Battle *</param>
        /// <param name="key">const char *</param>
        /// <returns>bool</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_HasVolatileScript")]
        internal static extern bool HasVolatileScript(IntPtr p, IntPtr key);

        /// <param name="p">Battle *</param>
        /// <param name="func">Function *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_RegisterEventListener")]
        internal static extern byte RegisterEventListener(IntPtr p, IntPtr func);

        /// <param name="p">Battle *</param>
        /// <param name="data">EventData *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_Battle_TriggerEventListener")]
        internal static extern byte TriggerEventListener(IntPtr p, IntPtr data);

    }
}
