using System;
using System.Runtime.InteropServices;

namespace Creatureliblibrary.Generated
{
    internal static class CreatureSpecies
    {
        /// <param name="out">CreatureSpecies *&</param>
        /// <param name="id">unsigned short</param>
        /// <param name="name">const char *</param>
        /// <param name="defaultVariant">SpeciesVariant *</param>
        /// <param name="genderRatio">float</param>
        /// <param name="growthRate">const char *</param>
        /// <param name="captureRate">unsigned char</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_Construct")]
        internal static extern byte Construct(ref IntPtr @out, ushort id, IntPtr name, IntPtr defaultVariant, float genderRatio, IntPtr growthRate, byte captureRate);

        /// <param name="p">const CreatureSpecies *</param>
        /// <returns>void</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_Destruct")]
        internal static extern void Destruct(IntPtr p);

        /// <param name="p">const CreatureSpecies *</param>
        /// <returns>unsigned short</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_GetId")]
        internal static extern ushort GetId(IntPtr p);

        /// <param name="p">const CreatureSpecies *</param>
        /// <returns>float</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_GetGenderRate")]
        internal static extern float GetGenderRate(IntPtr p);

        /// <param name="p">const CreatureSpecies *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_GetCaptureRate")]
        internal static extern byte GetCaptureRate(IntPtr p);

        /// <param name="p">const CreatureSpecies *</param>
        /// <returns>const char *</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_GetName")]
        internal static extern IntPtr GetName(IntPtr p);

        /// <param name="p">const CreatureSpecies *</param>
        /// <returns>const char *</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_GetGrowthRate")]
        internal static extern IntPtr GetGrowthRate(IntPtr p);

        /// <param name="p">const CreatureSpecies *</param>
        /// <param name="name">const char *</param>
        /// <returns>bool</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_HasVariant")]
        internal static extern bool HasVariant(IntPtr p, IntPtr name);

        /// <param name="p">const CreatureSpecies *</param>
        /// <param name="hash">unsigned int</param>
        /// <returns>bool</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_HasVariantWithHash")]
        internal static extern bool HasVariantWithHash(IntPtr p, uint hash);

        /// <param name="p">const CreatureSpecies *</param>
        /// <param name="name">const char *</param>
        /// <param name="out">const SpeciesVariant *&</param>
        /// <returns>bool</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_TryGetVariant")]
        internal static extern bool TryGetVariant(IntPtr p, IntPtr name, ref IntPtr @out);

        /// <param name="p">const CreatureSpecies *</param>
        /// <param name="hash">unsigned int</param>
        /// <param name="out">const SpeciesVariant *&</param>
        /// <returns>bool</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_TryGetVariantWithHash")]
        internal static extern bool TryGetVariantWithHash(IntPtr p, uint hash, ref IntPtr @out);

        /// <param name="out">const SpeciesVariant *&</param>
        /// <param name="p">const CreatureSpecies *</param>
        /// <param name="name">const char *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_GetVariant")]
        internal static extern byte GetVariant(ref IntPtr @out, IntPtr p, IntPtr name);

        /// <param name="out">const SpeciesVariant *</param>
        /// <param name="p">const CreatureSpecies *</param>
        /// <param name="hash">unsigned int</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_CreatureSpecies_GetVariantWithHash")]
        internal static extern byte GetVariantWithHash(IntPtr @out, IntPtr p, uint hash);

    }
}
