using System;
using System.Runtime.InteropServices;

namespace Pkmnlib.Generated
{
    internal static class Evolution
    {
        /// <param name="time">TimeOfDay</param>
        /// <param name="into">const PokemonSpecies *</param>
        /// <returns>const EvolutionData *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_CreateTimeEvolution")]
        internal static extern IntPtr CreateTimeEvolution(TimeOfDay time, IntPtr into);

        /// <param name="item">const Item *</param>
        /// <param name="into">const PokemonSpecies *</param>
        /// <returns>const EvolutionData *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_CreateItemEvolution")]
        internal static extern IntPtr CreateItemEvolution(IntPtr item, IntPtr into);

        /// <param name="gender">Gender</param>
        /// <param name="level">unsigned char</param>
        /// <param name="into">const PokemonSpecies *</param>
        /// <returns>const EvolutionData *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_CreateGenderBasedEvolution")]
        internal static extern IntPtr CreateGenderBasedEvolution(Gender gender, byte level, IntPtr into);

        /// <param name="item">const Item *</param>
        /// <param name="into">const PokemonSpecies *</param>
        /// <returns>const EvolutionData *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_CreateItemUseEvolution")]
        internal static extern IntPtr CreateItemUseEvolution(IntPtr item, IntPtr into);

        /// <param name="item">const Item *</param>
        /// <param name="gender">Gender</param>
        /// <param name="into">const PokemonSpecies *</param>
        /// <returns>const EvolutionData *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_CreateItemUseWithGenderEvolution")]
        internal static extern IntPtr CreateItemUseWithGenderEvolution(IntPtr item, Gender gender, IntPtr into);

        /// <param name="into">const PokemonSpecies *</param>
        /// <returns>const EvolutionData *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_CreateTradeEvolution")]
        internal static extern IntPtr CreateTradeEvolution(IntPtr into);

        /// <param name="item">const Item *</param>
        /// <param name="into">const PokemonSpecies *</param>
        /// <returns>const EvolutionData *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_CreateTradeWithItemEvolution")]
        internal static extern IntPtr CreateTradeWithItemEvolution(IntPtr item, IntPtr into);

        /// <param name="traded">const PokemonSpecies *</param>
        /// <param name="into">const PokemonSpecies *</param>
        /// <returns>const EvolutionData *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_CreateTradeWithSpeciesEvolution")]
        internal static extern IntPtr CreateTradeWithSpeciesEvolution(IntPtr traded, IntPtr into);

        /// <param name="data">const EffectParameter * *</param>
        /// <param name="dataLength">long unsigned int</param>
        /// <param name="into">const PokemonSpecies *</param>
        /// <returns>const EvolutionData *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_CreateCustomEvolution")]
        internal static extern IntPtr CreateCustomEvolution(IntPtr data, ulong dataLength, IntPtr into);

        /// <param name="data">const EvolutionData *</param>
        /// <returns>EvolutionMethod</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_GetMethod")]
        internal static extern EvolutionMethod GetMethod(IntPtr data);

        /// <param name="data">const EvolutionData *</param>
        /// <returns>const PokemonSpecies *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_GetNewSpecies")]
        internal static extern IntPtr GetNewSpecies(IntPtr data);

        /// <param name="data">const EvolutionData *</param>
        /// <returns>long unsigned int</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_GetDataCount")]
        internal static extern ulong GetDataCount(IntPtr data);

        /// <param name="data">const EvolutionData *</param>
        /// <param name="index">long unsigned int</param>
        /// <param name="out">const EffectParameter *&</param>
        /// <returns>unsigned char</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Evolution_GetData")]
        internal static extern byte GetData(IntPtr data, ulong index, ref IntPtr @out);

    }
}
