using System;
using System.Runtime.InteropServices;

namespace Pkmnlib.Generated
{
    internal static class Pokemon
    {
        /// <param name="library">const BattleLibrary *</param>
        /// <param name="species">const PokemonSpecies *</param>
        /// <param name="forme">const PokemonForme *</param>
        /// <param name="level">unsigned char</param>
        /// <param name="experience">unsigned int</param>
        /// <param name="uid">unsigned int</param>
        /// <param name="gender">Gender</param>
        /// <param name="coloring">unsigned char</param>
        /// <param name="heldItem">const Item *</param>
        /// <param name="nickname">const char *</param>
        /// <param name="hiddenAbility">bool</param>
        /// <param name="abilityIndex">unsigned char</param>
        /// <param name="moves">const LearnedAttack * *</param>
        /// <param name="moveCount">long unsigned int</param>
        /// <param name="hpIv">unsigned char</param>
        /// <param name="attIv">unsigned char</param>
        /// <param name="defIv">unsigned char</param>
        /// <param name="sAtIv">unsigned char</param>
        /// <param name="sDeIv">unsigned char</param>
        /// <param name="spIv">unsigned char</param>
        /// <param name="hpEv">unsigned char</param>
        /// <param name="attEv">unsigned char</param>
        /// <param name="defEv">unsigned char</param>
        /// <param name="sAtEv">unsigned char</param>
        /// <param name="sDeEv">unsigned char</param>
        /// <param name="spEv">unsigned char</param>
        /// <param name="nature">const Nature *</param>
        /// <returns>Pokemon *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Pokemon_Construct")]
        internal static extern IntPtr Construct(IntPtr library, IntPtr species, IntPtr forme, byte level, uint experience, uint uid, Gender gender, byte coloring, IntPtr heldItem, IntPtr nickname, bool hiddenAbility, byte abilityIndex, IntPtr moves, ulong moveCount, byte hpIv, byte attIv, byte defIv, byte sAtIv, byte sDeIv, byte spIv, byte hpEv, byte attEv, byte defEv, byte sAtEv, byte sDeEv, byte spEv, IntPtr nature);

        /// <param name="p">const Pokemon *</param>
        /// <returns>void</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Pokemon_Destruct")]
        internal static extern void Destruct(IntPtr p);

        /// <param name="p">const Pokemon *</param>
        /// <returns>bool</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Pokemon_IsShiny")]
        internal static extern bool IsShiny(IntPtr p);

        /// <param name="p">const Pokemon *</param>
        /// <returns>const Nature *</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Pokemon_GetNature")]
        internal static extern IntPtr GetNature(IntPtr p);

        /// <param name="p">const Pokemon *</param>
        /// <param name="stat">Statistic</param>
        /// <returns>unsigned char</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Pokemon_GetIndividualValue")]
        internal static extern byte GetIndividualValue(IntPtr p, Statistic stat);

        /// <param name="p">const Pokemon *</param>
        /// <param name="stat">Statistic</param>
        /// <returns>unsigned char</returns>
        [DllImport("pkmnLib", CallingConvention = CallingConvention.Cdecl, EntryPoint= "PkmnLib_Pokemon_GetEffortValue")]
        internal static extern byte GetEffortValue(IntPtr p, Statistic stat);

    }
}
