using System;
using Pkmnlib;
using PkmnLibSharp.Utilities;

namespace PkmnLibSharp.Library
{
    public class EffectParameter : PointerWrapper
    {
        public EffectParameter(string s) : base(Creatureliblibrary.Generated.EffectParameter.FromString(s.ToPtr()))
        {
        }

        public EffectParameter(bool b) : base(Creatureliblibrary.Generated.EffectParameter.FromBool(b))
        {
        }

        public EffectParameter(long l) : base(Creatureliblibrary.Generated.EffectParameter.FromInt(l))
        {
        }

        public EffectParameter(float f) : base(Creatureliblibrary.Generated.EffectParameter.FromFloat(f))
        {
        }

        public EffectParameterType ParameterType =>
            (EffectParameterType) Creatureliblibrary.Generated.EffectParameter.GetType(Ptr);

        public bool AsBool()
        {
            bool b = false;
            Creatureliblibrary.Generated.EffectParameter.AsBool(Ptr, ref b).Assert();
            return b;
        }
        
        public long AsInt()
        {
            long i = 0;
            Creatureliblibrary.Generated.EffectParameter.AsInt(Ptr, ref i).Assert();
            return i;
        }

        public float AsFloat()
        {
            float f = 0;
            Creatureliblibrary.Generated.EffectParameter.AsFloat(Ptr, ref f).Assert();
            return f;
        }

        public string AsString()
        {
            IntPtr p = IntPtr.Zero;
            Creatureliblibrary.Generated.EffectParameter.AsString(Ptr, ref p).Assert();
            return p.PtrString();
        }



        internal override void DeletePtr()
        {
            Creatureliblibrary.Generated.EffectParameter.Destruct(Ptr);
        }
    }
}